# Kyverno Adopters

This is the list of organizations and users that have publicly shared how they are using Kyverno. 

**Please send PRs to add or remove organizations and users.**

Note: There are several other organizations and users that are not able to publicly share their stories, but are active in the Kyverno community. We appreciate all users and their contributions to making Kyverno a successful CNCF project.

The list of organizations that have publicly shared the usage of Kyverno:

| Organization | Success Story |
| :--- | :--- |
| [Amazon EKS Best Practice Guides](https://github.com/aws/aws-eks-best-practices/tree/master/policies/kyverno) | Policies for security and best practices |
| [Flux2](https://github.com/fluxcd/flux2-multi-tenancy#enforce-tenant-isolation) | Manage multi-tenancy and tenant isolation with GitOps |
| [Nirmata](https://nirmata.com) | Kubernetes policy-as-code and multi-tenancy |
| [Ohio Supercomputer Center](https://www.osc.edu/) | Support Kubernetes multi-user workflows through [Open OnDemand](http://openondemand.org/) |
| [Coinbase](https://www.coinbase.com/)  | Use Kyverno for mutation, to replace hand-written Webhooks, and generation to project common Kubernetes objects into many similar namespaces. |
| [Mandiant](https://www.mandiant.com/)  | Use Kyverno for policy enforcement in all clusters, as well as part of our onboarding systems, populating new namespaces with requisite resources and secrets. |
| [Giant Swarm](https://www.giantswarm.io/) | Use Kyverno extensively to handle defaulting logic on resources (primarily cluster-api resources) and some scenarios to replace PSPs to enforce certain restrictions. |
| [Vodafone Group Plc](https://www.vodafone.com/)  | Policy enforcement and automation on an internal k8s service offering. |
| [Deutsche Telekom](https://www.telekom.com/en)  | Use Kyverno to enforce Policies on managed clusters to prevent right escalation of internal customers and to enforce security rules. |
| [VSHN AG - APPUiO Cloud](https://www.vshn.ch/) | OpenShift Multi-Tenancy Self-Service for [APPUiO Cloud](https://www.appuio.ch), managed with [Project Syn](https://syn.tools). Kyverno policies are available on [GitHub](https://github.com/appuio/component-appuio-cloud). |
| [Bloomberg](https://www.techatbloomberg.com/) | Use Kyverno for replacing custom validation and mutation webhooks in their internal Kubernetes based platforms |
<!-- append the line below to the table
| [name](URL) | brief description of how you are using Kyverno | 

-->


Here is a list of individual users that have publicly shared usage of Kyverno:

| User  | Success Story |
| :--- | :--- |
| [Chip Zoller](https://github.com/chipzoller) | Using Kyverno to develop community policies and audit best practices for ecosystem projects |
| [Greg May](https://github.com/mnrgreg) | Managing enterprise, self-service, namespace-based multi-tenancy using Kyverno policy and namespace labels |
| [Trey Dockendorf](https://github.com/treydock) | Kubernetes with Open OnDemand and Kyverno |

<!-- append the line below and tell your story
| [name](GitHub URL) | brief description | 
-->
