package framework

import (
	"os"
	"testing"

	"github.com/kyverno/kyverno/test/e2e/framework/client"
	"github.com/kyverno/kyverno/test/e2e/framework/step"
	"github.com/onsi/ginkgo"
	"github.com/onsi/gomega"
)

func Setup(t *testing.T) {
	gomega.RegisterTestingT(t)
	if os.Getenv("E2E") == "" {
		t.Skip("Skipping E2E Test")
	}
}

func Run(t *testing.T, steps ...step.Step) {
	ginkgo.By("Creating client ...")
	client := client.New(t)
	for _, step := range steps {
		step(client)
	}
	ginkgo.By("Cleaning up ...")
}
